/*
 * mainloop.cpp
 *
 *  Created on: Sep 11, 2019
 *      Author: abody
 */

#include <ili9341.h>
#include <application.h>
#include <initializer_list>
#include "main.h"
#include "globals.h"

#define BORDER 60
#define BARWIDTH 2



void MainLoop()
{
	Application	m;

	m.Loop();
}

Application::Application()
: GlobalsInitializer(&m_console)
, m_console(USART1, DMA2, LL_DMA_STREAM_2, LL_DMA_STREAM_7, this, nullptr)
{
}

void Application::Loop()
{
	//LL_SYSTICK_EnableIT();

	Ili9341Fsmc &lcd(Ili9341Fsmc::Init(nullptr, nullptr, DMA2, LL_DMA_STREAM_4, false));

	lcd.FillRect(Ili9341Fsmc::ILI9341_BLACK, false);
	//lcd.Test();
	lcd.SetCursor( 10, 10, Ili9341Fsmc::ILI9341_WHITE, Ili9341Fsmc::ILI9341_BLACK);
	lcd.Print("Baszod");

	for(;;) {
		if(m_received && m_transmitted) {
			m_transmitted = false;
			m_console.SendLine(reinterpret_cast<char*>(const_cast<char*>(m_rcvdBuffer->buffer)), m_rcvdBuffer->len);
			m_received = false;
			m_rcvdBuffer->busy = false;
		}
	}
	//LL_GPIO_TogglePin(LED1_GPIO_Port, LED1_Pin);
	//LL_GPIO_TogglePin(LED2_GPIO_Port, LED2_Pin);
	//LL_mDelay(25);
}

void Application::LineReceived(void *userParam, SerialConsole<257>::Buffer *buffer)
{
	m_received = true;
	m_rcvdBuffer = buffer;
}

void Application::TransmissionComplete(void *userParam, SerialConsole<257>::Buffer *buffer)
{
	m_transmitted = true;
}

